#include "cgul_char.h"

int
cgul_char__strcmp(const char* s1,
                  const char* s2)
{
    int rv = 0;

    assert(s1);
    assert(s2);

    /* Iterate over s1 and s2 searching for the first character that
     * differs. */
    for ( ; *s1 && *s2 ; ++s1, ++s2) {

        /* If this character in s1 is less than its counterpart in
         * s2, the s1 string is less than the s2 string. */
        if (*s1 < *s2) {
            rv = -1;
            goto out;
        }

        /* If this character in s1 is greater than its counterpart in
         * s2, the s1 string is greater than the s2 string. */
        if (*s1 > *s2) {
            rv = 1;
            goto out;
        }
    }

    /* If the loop above reached the end of both strings, they are equal. */
    if ((*s1 == '\0') && (*s2 == '\0')) {
        rv = 0;
        goto out;
    }

    /* If the loop above reached the end of s1 only, s1 is less than s2. */
    if (*s1 == '\0') {
        rv = -1;
        goto out;
    }

    /* The loop above must have reached the end of s2 in which case s1
     * is greater than s2. */
    assert(*s2 == '\0');
    rv = 1;

 out:
    return rv;
}

int
cgul_char__isspace(cgul_exception_t* cex,
                   char c)
{
    int rv = 0;

    assert(cex);
    if (*cex) {
        goto out;
    }

    switch (c) {
    case ' ':
    case '\t':
    case '\n':
    case '\r':
    case '\f':
    case '\v':
        rv = 1;
        break;
    default:
        break;
    }

 out:
    return rv;
}
