#ifndef CGUL_PROGRESS_BAR_P_H
#define CGUL_PROGRESS_BAR_P_H

#include "cgul_progress_bar.h"

CGUL_BEGIN_C

/** Data encapsulated by the <code>cgul_progress_bar</code> class. */
struct cgul_progress_bar {

    /**
     * The minimum value for the range which coincides with 0%
     * progress.
     */
    double min;

    /**
     * The maximum value for the range which coincides with 100%
     * progress.
     */
    double max;

    /**
     * The style of progress bar.
     */
    cgul_progress_bar__style_t style;

    /**
     * For the <code>CGUL_PROGRESS_BAR__SIMPLE</code>, there are
     * exactly 40 ticks in one progress bar, and we have to keep track
     * of which tick was drawn last.
     */
    int ticks;

    /**
     * Where to draw the progress indicator.
     */
    FILE* f;

};

CGUL_END_C

#endif  /*  CGUL_PROGRESS_BAR_P_H  */
