#ifndef CGUL_STRTOK_P_H
#define CGUL_STRTOK_P_H

#include "cgul_strtok.h"

CGUL_BEGIN_C

/** Data encapsulated by the <code>cgul_strtok</code> class. */
struct cgul_strtok {

    /**
     * The separator that marks the end of the current token.
     */
    char separator;

    /**
     * The value to tokenize.  This is a copy of the string passed
     * into <code>cgul_strtok__set_value()</code>.  The separators in
     * the string will be overwritten with <code>'\0'</code>
     * characters as tokenization proceeds.
     */
    char* value;

    /**
     * The length of the <code>value</code> string.
     */
    size_t value_length;

    /**
     * The starting index into <code>value</code> of the current token.
     */
    size_t start;

    /**
     * The ending index into <code>value</code> of the current token.
     */
    size_t end;

    /**
     * <code>start</code> has to be set to just past the end of the
     * last token except on the first pass.
     */
    int is_first_pass;

};

CGUL_END_C

#endif  /*  CGUL_STRTOK_P_H  */
