#include <unistd.h>
#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int main(int argc, char* argv[])
{
    int rv = 0;
    unsigned int result = 0;
    size_t rcount = 0;
    unsigned char buf[16384];

    try {

        cgul_crc16_cxx crc16(0x1021, 0xffff, 0xffff, 0);

        for (;;) {

            rcount = read(STDIN_FILENO, buf, sizeof(buf));
            if (rcount <= 0) {
                break;
            }

            crc16.update_block(buf, rcount);
        }

        result = crc16.crc();
        cout << result << "  0x" << hex << result << endl;

    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
