/*
 * This program reads stdin into memory and then uses cgul_crlf_file
 * to parse the memory.
 */

#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* buf = NULL;
    size_t buf_size = 0;
    const char* line = NULL;

    try {

        /* Read stdin into s. */
        cgul_libc_cxx::load_file(stdin, &buf, &buf_size);

        /* Open memory for crlf processing. */
        cgul_crlf_file_cxx crlf;
        crlf.open_memory(buf, buf_size);

        /* Iterate over each line. */
        while ((line = crlf.get_line()) != NULL) {
            puts(line);
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    /* Clean up. */
    if (buf) {
        free(buf);
    }

    return rv;
}
