#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_int16_t   x16 = 0x0123;
    cgul_int32_t   x32 = 0x01234567;
#ifdef CGUL_INT64
    cgul_int64_t   x64 = 0x0123456789abcdef;
#endif
    cgul_exception_t local = NULL;

    /*************************************************************************
     * Detect
     *************************************************************************/

    printf("              cgul_endian__is_big_endian() = %d\n",
           cgul_endian__is_big_endian(&local));
    printf("           cgul_endian__is_little_endian() = %d\n",
           cgul_endian__is_little_endian(&local));
    puts("");

    /*************************************************************************
     * Swap Integers
     *************************************************************************/

    /* 16-bit signed values */
    printf("                                       x16 = 0x%04hx\n", x16);
    cgul_endian__swap(&local, (char*)&x16, sizeof(x16));
    printf("      cgul_endian__swap(&x16, sizeof(x16)) = 0x%04hx\n", x16);
    puts("");

    /* 32-bit signed values */
    printf("                                       x32 = 0x%08x\n", x32);
    cgul_endian__swap(&local, (char*)&x32, sizeof(x32));
    printf("      cgul_endian__swap(&x32, sizeof(x32)) = 0x%08x\n", x32);
    puts("");


#ifdef CGUL_INT64
    /* 64-bit signed values */
    printf("                                       x64 = 0x%016lx\n", x64);
    cgul_endian__swap(&local, (char*)&x64, sizeof(x64));
    printf("      cgul_endian__swap(&x64, sizeof(x64)) = 0x%016lx\n", x64);
    puts("");
#endif

    return rv;
}
