/*
 * Test program to make sure cgul_int.h is picking up the right types.
 * On some 32-bit systems, you can compile with the following gcc
 * option to enable 64-bit "long long" and "unsigned long long" types:
 *
 *     gcc --std=gnu99
 */

#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;

    /* Print the sizes for all the types defined in cgul_int.h. */
    printf("sizeof(cgul_int8_t)   = %d\n", (int)sizeof(cgul_int8_t));
    printf("sizeof(cgul_uint8_t)  = %d\n", (int)sizeof(cgul_uint8_t));
    printf("sizeof(cgul_int16_t)  = %d\n", (int)sizeof(cgul_int16_t));
    printf("sizeof(cgul_uint16_t) = %d\n", (int)sizeof(cgul_uint16_t));
    printf("sizeof(cgul_int32_t)  = %d\n", (int)sizeof(cgul_int32_t));
    printf("sizeof(cgul_uint32_t) = %d\n", (int)sizeof(cgul_uint32_t));
#ifdef CGUL_INT64
    printf("sizeof(cgul_int64_t)  = %d\n", (int)sizeof(cgul_int64_t));
#endif
#ifdef CGUL_UINT64
    printf("sizeof(cgul_uint64_t) = %d\n", (int)sizeof(cgul_uint64_t));
#endif

    return rv;
}
