#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_string_t s = NULL;
    cgul_bdf_t bdf = NULL;
    cgul_exception_t local = NULL;

    /* Load the font. */
    bdf = cgul_bdf__new(&local);
    cgul_bdf__load(&local, bdf, "dejavu_sans-14.bdf");

    s = cgul_string__new_from_cstring(&local, "Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.");

    /* Wrap the string. */
#if 1
    cgul_line_wrapper__wrap_utf8_at_width(&local, s, bdf, 1, 640);
#else
    cgul_line_wrapper__wrap_utf8_at_column(&local, s, 72);
#endif

    if (local) {
        goto out;
    }

    /* Print the results. */
    printf("%s\n", cgul_string__get_value(&local, s));

    if (local) {
        goto out;
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (s) {
        cgul_string__delete(s);
    }

    if (bdf) {
        cgul_bdf__delete(bdf);
    }

    return rv;
}
