#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_list_t lst = NULL;
    cgul_list_node_t curr = NULL;
    cgul_list_node_t foo = NULL;
    cgul_list_node_t bar = NULL;
    cgul_list_node_t baz = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    lst = cgul_list__new(&local);
    if (local) {
        goto out;
    }

    /* Insert strings. */
    foo = cgul_list__push_back(&local, lst, "foo");
    bar = cgul_list__push_back(&local, lst, "bar");
    baz = cgul_list__push_back(&local, lst, "baz");

    /* Move nodes. */
    cgul_list__move_before_node(&local, lst, NULL, foo);
    cgul_list__move_after_node(&local, lst, NULL, foo);
    cgul_list__move_after_node(&local, lst, foo, bar);

    /* Test to make sure trying to move a node before and after itself
     * do not change the list. */
    cgul_list__move_before_node(&local, lst, baz, baz);
    cgul_list__move_after_node(&local, lst, baz, baz);

    /* Print strings. */
    curr = cgul_list__get_front(&local, lst);
    for ( ; curr ; curr = cgul_list_node__get_next(&local, curr)) {
        puts(cgul_list_node__get_value(&local, curr));        
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (lst) {
        cgul_list__delete(lst);
    }

    return rv;
}
