#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    int i = 0;
    cgul_progress_bar_t bar = NULL;
    cgul_string_t s = NULL;
    cgul_exception_t local = NULL;

    bar = cgul_progress_bar__new(&local);
    s = cgul_string__new(&local);
    if (local) {
        goto out;
    }

    cgul_progress_bar__set_min(&local, bar, 0);
    cgul_progress_bar__set_max(&local, bar, 10);

    /* Draw the simple bar. */
    cgul_progress_bar__set_style(&local, bar, CGUL_PROGRESS_BAR__SIMPLE);
    for (i = 0 ; i <= 10 ; ++i) {
        cgul_progress_bar__update(&local, bar, i, NULL, NULL);
        if (local) {
            goto out;
        }
        /* sleep(1); */
    }

    printf("\n");

    /* Draw a common-style bar. */
    cgul_progress_bar__reset(&local, bar);
    cgul_progress_bar__set_style(&local, bar, CGUL_PROGRESS_BAR__COMMON);
    for (i = 0 ; i <= 10 ; ++i) {
        cgul_string__set_value(&local, s, "");
        cgul_string__append_sprintf(&local, s, "%d/%d", i, 10);
        cgul_string__pad_right(&local, s, 5, ' ');
        cgul_progress_bar__update(&local,
                                  bar,
                                  i,
                                  "before:",
                                  cgul_string__get_value(&local, s));
        if (local) {
            goto out;
        }
        /* sleep(1); */
    }

#if 0
    /* Show that the common-style bar can run in reverse. */
    for (i = 9 ; i >= 0 ; --i) {
        cgul_string__set_value(&local, s, "");
        cgul_string__append_sprintf(&local, s, "%d/%d", i, 10);
        cgul_string__pad_right(&local, s, 5, ' ');
        cgul_progress_bar__update(&local,
                                  bar,
                                  i,
                                  "before:",
                                  cgul_string__get_value(&local, s));
        if (local) {
            goto out;
        }
        /* sleep(1); */
    }
#endif

        printf("\n");

 out:

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (s) {
        cgul_string__delete(s);
    }

    if (bar) {
        cgul_progress_bar__delete(bar);
    }

    return rv;
}
