#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    cgul_string_t s = NULL;
    cgul_exception_t local = NULL;
    const char* tests[] = {
        "", "f", "   f   ", "foo", "   foo  ", "        ", NULL
    };

    /* Allocate. */
    s = cgul_string__new(&local);
    if (local) {
        goto out;
    }

    /* Trim Left: Iterate over the test strings. */
    for (i = 0 ; tests[i] ; ++i) {
        cgul_string__set_value(&local, s, tests[i]);
        cgul_string__trim_left(&local, s);
        printf(" trim_left(): \"%s\" --> \"%s\"\n",
               tests[i],
               cgul_string__get_value(&local, s));
    }

    printf("=====\n");

    /* Trim Right: Iterate over the test strings. */
    for (i = 0 ; tests[i] ; ++i) {
        cgul_string__set_value(&local, s, tests[i]);
        cgul_string__trim_right(&local, s);
        printf("trim_right(): \"%s\" --> \"%s\"\n",
               tests[i],
               cgul_string__get_value(&local, s));
    }

    printf("=====\n");

    /* Trim: Iterate over the test strings. */
    for (i = 0 ; tests[i] ; ++i) {
        cgul_string__set_value(&local, s, tests[i]);
        cgul_string__trim(&local, s);
        printf("      trim(): \"%s\" --> \"%s\"\n",
               tests[i],
               cgul_string__get_value(&local, s));
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
