#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    cgul_string_cxx s;
    const char* tests[] = {
        "", "f", "   f   ", "foo", "   foo  ", "        ", NULL
    };

    try {

        /* Trim Left: Iterate over the test strings. */
        for (i = 0 ; tests[i] ; ++i) {
            s = tests[i];
            s.trim_left();
            printf(" trim_left(): \"%s\" --> \"%s\"\n",
                   tests[i],
                   s.get_value());
        }

        printf("=====\n");

        /* Trim Right: Iterate over the test strings. */
        for (i = 0 ; tests[i] ; ++i) {
            s = tests[i];
            s.trim_right();
            printf("trim_right(): \"%s\" --> \"%s\"\n",
                   tests[i],
                   s.get_value());
        }

        printf("=====\n");

        /* Trim: Iterate over the test strings. */
        for (i = 0 ; tests[i] ; ++i) {
            s = tests[i];
            s.trim();
            printf("      trim(): \"%s\" --> \"%s\"\n",
                   tests[i],
                   s.get_value());
        }

    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
    }

    return rv;
}
