#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    const char* s = NULL;
    cgul_strtok_t tok = NULL;
    cgul_exception_t local = NULL;

    /* Allocate the tokenizer. */
    tok = cgul_strtok__new(&local);
    if (local) {
        goto out;
    }

    /* Set the string to tokenize. */
    cgul_strtok__set_value(&local, tok, ",foo,bar,baz,");
    if (local) {
        goto out;
    }

    /* Iterate over each token. */
    while ((s = cgul_strtok__get_next(&local, tok, ",", 1)) != NULL) {
        cgul_libc__printf(&local, "    token: \"%s\"\n", s);
        cgul_libc__printf(&local, "separator: \"%c\"\n",
                          cgul_strtok__get_separator(&local, tok));
        cgul_libc__printf(&local, "    start: %lu\n",
                          (unsigned long)cgul_strtok__get_start(&local, tok));
        cgul_libc__printf(&local, "      end: %lu\n",
                          (unsigned long)cgul_strtok__get_end(&local, tok));
        cgul_libc__printf(&local, "\n");
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (tok) {
        cgul_strtok__delete(tok);
    }

    return rv;
}
