#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    cgul_string_cxx utf8;
    cgul_wstring_cxx utf32;

    try {

#if 0
    {
        cgul_wchar_t hello[] = {'h', 'e', 'l', 'l', 'o', CGUL_WCHAR__NUL};
        utf32.set_value(hello);
    }
#endif

        /* Set the minimum capacity to 2 (one character plus NUL-terminator). */
        utf32.set_minimum_capacity(2);

        /* Create the string one character at a time.  Note that the
         * final string needs a capacity of (16 + 1) including the
         * NUL-terminator. */
        for (i = 0 ; i < 16 ; ++i) {

            /* Append the next character. */
            utf32.append_char('z');

            /* Convert from UTF-32 to UTF-8. */
            utf8.set_length(0);
            cgul_unicode_cxx::wcstombs(utf32.get_value(),
                                       utf32.get_length(),
                                       /* skip_bom */ 1,
                                       utf8);

            /* Print the new value of the string. */
            printf("-->%s<--\n", utf8.get_value());
        }

        /* Reduce the size of the string one character at a time. */
        for (i = utf32.get_length() ; i > 0 ; --i) {

            /* Reduce the size of the string by one by removing the
             * trailing character. */
            utf32.set_length(i - 1);

            /* Convert from UTF-32 to UTF-8. */
            utf8.set_length(0);
            cgul_unicode_cxx::wcstombs(utf32.get_value(),
                                       utf32.get_length(),
                                       /* skip_bom */ 1,
                                       utf8);

            /* Print the new value of the string. */
            printf("-->%s<--\n", utf8.get_value());
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
