#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    cgul_string_cxx utf8;
    cgul_wstring_cxx utf32;
    const char* tests[] = {
        "", "f", "   f   ", "foo", "   foo  ", "        ", NULL
    };

    try {

        /* Trim Left: Iterate over the test strings. */
        for (i = 0 ; tests[i] ; ++i) {
            /* Convert from UTF-8 to UTF-32. */
            utf32 = CGUL_WCHAR__EMPTY_STRING;
            cgul_unicode_cxx::mbstowcs(tests[i],
                                       strlen(tests[i]),
                                       1,  /* skip_bom */
                                       utf32);
            /* Trim. */
            utf32.trim_left();
            /* Convert back to UTF-8. */
            utf8 = "";
            cgul_unicode_cxx::wcstombs(utf32.get_value(),
                                       utf32.get_length(),
                                       1,  /* skip_bom */
                                       utf8);
            /* Print result. */
            printf(" trim_left(): \"%s\" --> \"%s\"\n",
                   tests[i],
                   utf8.get_value());
        }

        printf("=====\n");

        /* Trim Right: Iterate over the test strings. */
        for (i = 0 ; tests[i] ; ++i) {
            /* Convert from UTF-8 to UTF-32. */
            utf32 = CGUL_WCHAR__EMPTY_STRING;
            cgul_unicode_cxx::mbstowcs(tests[i],
                                       strlen(tests[i]),
                                       1,  /* skip_bom */
                                       utf32);
            /* Trim. */
            utf32.trim_right();
            /* Convert back to UTF-8. */
            utf8 = "";
            cgul_unicode_cxx::wcstombs(utf32.get_value(),
                                       utf32.get_length(),
                                       1,  /* skip_bom */
                                       utf8);
            /* Print result. */
            printf("trim_right(): \"%s\" --> \"%s\"\n",
                   tests[i],
                   utf8.get_value());
        }

        printf("=====\n");

        /* Trim: Iterate over the test strings. */
        for (i = 0 ; tests[i] ; ++i) {
            /* Convert from UTF-8 to UTF-32. */
            utf32 = CGUL_WCHAR__EMPTY_STRING;
            cgul_unicode_cxx::mbstowcs(tests[i],
                                       strlen(tests[i]),
                                       1,  /* skip_bom */
                                       utf32);
            /* Trim. */
            utf32.trim();
            /* Convert back to UTF-8. */
            utf8 = "";
            cgul_unicode_cxx::wcstombs(utf32.get_value(),
                                       utf32.get_length(),
                                       1,  /* skip_bom */
                                       utf8);
            /* Print result. */
            printf("      trim(): \"%s\" --> \"%s\"\n",
                   tests[i],
                   utf8.get_value());
        }

    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
    }

    return rv;
}
